'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp; //外部依赖包

// import AInput from 'antd/lib/input';

//内部依赖包


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _radio = require('antd/lib/radio');

var _radio2 = _interopRequireDefault(_radio);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _util = require('../../utils/util');

var _form = require('../form');

var _form2 = _interopRequireDefault(_form);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioButton = _radio2.default.Button;
var RadioGroup = _radio2.default.Group;

_input2.default.displayName = 'OriginalAntdComponent';

var MultipleInput = (_temp = _class = function (_Input) {
  (0, _inherits3.default)(MultipleInput, _Input);

  function MultipleInput(props) {
    (0, _classCallCheck3.default)(this, MultipleInput);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MultipleInput.__proto__ || (0, _getPrototypeOf2.default)(MultipleInput)).call(this, props));

    _this.componentType = 'multiple-input';

    _this.onRadioChange = function (index) {
      return function (e) {
        var triggerEvent = _this.context.triggerEvent;

        var data = _this.itemKeys;
        switch (e.target.value) {
          case 'up':
            (0, _util.swapArrayItem)(data, index, index - 1);
            triggerEvent('array-item-index-change', {
              name: _this.props.name,
              arrayItemIndexs: data
            });
            break;
          case 'down':
            (0, _util.swapArrayItem)(data, index, index + 1);
            triggerEvent('array-item-index-change', {
              name: _this.props.name,
              arrayItemIndexs: data
            });
            break;
          case 'delete':
            data.splice(index, 1);
            break;
          default:
        }

        _this.setState({});
      };
    };

    _this.onPlusClickEvent = function (e) {
      _this.itemKeys.push((0, _util.randomKey)());
      _this.setState({});
    };

    _this.itemKeys = [];
    var value = _this.props.value;

    if (!(0, _isArray2.default)(value)) {
      value = [value];
    }
    value.forEach(function (v) {
      _this.itemKeys.push((0, _util.randomKey)());
    });
    return _this;
  }

  (0, _createClass3.default)(MultipleInput, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isAntdComponentDeep: true,
        isArrayInput: true
      };
    }
  }, {
    key: 'getUpDisabled',
    value: function getUpDisabled(index) {
      if (this.itemKeys.length === 1) {
        return true;
      }
      if (index === 0) {
        return true;
      }
    }
  }, {
    key: 'getDownDisabled',
    value: function getDownDisabled(index) {
      if (this.itemKeys.length === 1) {
        return true;
      }
      if (index === this.itemKeys.length - 1) {
        return true;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$value = _props.value,
          value = _props$value === undefined ? [] : _props$value,
          other = (0, _objectWithoutProperties3.default)(_props, ['value']);

      var size = this.context.size || 'default';
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('afc-array-item clearfix', {
            'afc-array-item-small': size === 'small',
            'afc-array-item-default': size === 'default',
            'afc-array-item-large': size === 'large'
          })
        },
        this.itemKeys.map(function (v, k) {
          if (k !== 0) {
            other.label = 'null';
          }
          if (value[k] === undefined) {
            //因为下面需要转换成字符串了
            value[k] = '';
          }
          var hideLabel = other.label === 'null' ? true : false;
          return _react2.default.createElement(
            _form2.default.Item,
            {
              className: (0, _classnames2.default)({ 'afc-hide-label': hideLabel }),
              key: v
            },
            _this2.renderFormItem(_react2.default.createElement(
              'div',
              { className: 'afc-array-item-con' },
              _react2.default.createElement(
                'div',
                { className: 'afc-array-item-left' },
                _react2.default.createElement(_input2.default, null)
              ),
              _react2.default.createElement(
                'div',
                { className: 'afc-array-item-right' },
                _react2.default.createElement(
                  RadioGroup,
                  {
                    className: 'afc-array-item-radiogroup',
                    onChange: _this2.onRadioChange(k),
                    value: '',
                    size: size
                  },
                  _react2.default.createElement(
                    RadioButton,
                    { value: 'up', disabled: _this2.getUpDisabled(k) },
                    _react2.default.createElement(_icon2.default, { type: 'arrow-up' })
                  ),
                  _react2.default.createElement(
                    RadioButton,
                    {
                      value: 'down',
                      disabled: _this2.getDownDisabled(k)
                    },
                    _react2.default.createElement(_icon2.default, { type: 'arrow-down' })
                  ),
                  _react2.default.createElement(
                    RadioButton,
                    {
                      value: 'delete',
                      disabled: _this2.itemKeys.length === 1
                    },
                    _react2.default.createElement(_icon2.default, { type: 'delete' })
                  )
                )
              )
            ), {
              label: other.label,
              //_-_这个特殊符号是为了防止可能存在的重复name
              //同时用来提取前面的name值
              name: other.name + '_-_' + v,
              arrayItemIndexs: _this2.itemKeys,
              //如果是数字转换成字符串
              //input表单值不存在值为数字的情况。
              initialValue: (0, _isArray2.default)(value) ? value[k] + '' : value + ''
            })
          );
        }),
        _react2.default.createElement(
          _button2.default,
          {
            type: 'primary',
            className: 'afc-array-item-plus',
            onClick: this.onPlusClickEvent
          },
          _react2.default.createElement(_icon2.default, { type: 'plus' })
        )
      );
    }
  }]);
  return MultipleInput;
}(_index2.default), _class.childContextTypes = {
  //是否是多层jsx包裹
  isAntdComponentDeep: _propTypes2.default.bool,
  isArrayInput: _propTypes2.default.bool
}, _temp);
exports.default = MultipleInput;