'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class4, _temp5; //外部依赖包

//内部依赖包


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _basicComponent = require('../basic-component');

var _basicComponent2 = _interopRequireDefault(_basicComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_input2.default.displayName = 'OriginalAntdComponent';

var Input = function (_BasicComponent) {
  (0, _inherits3.default)(Input, _BasicComponent);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Input.__proto__ || (0, _getPrototypeOf2.default)(Input)).call.apply(_ref, [this].concat(args))), _this), _this.currentAntdComponent = _input2.default, _this.localeKey = 'afcInput', _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Input, [{
    key: 'getSepcialRuleByType',
    value: function getSepcialRuleByType(type) {
      //继承父类可能有的rules
      var rules = (0, _get3.default)(Input.prototype.__proto__ || (0, _getPrototypeOf2.default)(Input.prototype), 'getSepcialRuleByType', this).call(this);
      var locale = this.locale;
      switch (type) {
        case 'email':
          rules.push({
            type: 'email',
            message: locale.afcInput.emailFormat
          });
          break;
        case 'url':
          rules.push({
            type: 'url',
            message: locale.afcInput.urlFormat
          });
          break;
        default:
      }
      return rules;
    }
  }]);
  return Input;
}(_basicComponent2.default);

exports.default = Input;

Input.TextArea = function (_BasicComponent2) {
  (0, _inherits3.default)(InputTextArea, _BasicComponent2);

  function InputTextArea() {
    var _ref2;

    var _temp2, _this2, _ret2;

    (0, _classCallCheck3.default)(this, InputTextArea);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref2 = InputTextArea.__proto__ || (0, _getPrototypeOf2.default)(InputTextArea)).call.apply(_ref2, [this].concat(args))), _this2), _this2.currentAntdComponent = _input2.default.TextArea, _temp2), (0, _possibleConstructorReturn3.default)(_this2, _ret2);
  }

  return InputTextArea;
}(_basicComponent2.default);
Input.Search = function (_BasicComponent3) {
  (0, _inherits3.default)(InputSearch, _BasicComponent3);

  function InputSearch() {
    var _ref3;

    var _temp3, _this3, _ret3;

    (0, _classCallCheck3.default)(this, InputSearch);

    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret3 = (_temp3 = (_this3 = (0, _possibleConstructorReturn3.default)(this, (_ref3 = InputSearch.__proto__ || (0, _getPrototypeOf2.default)(InputSearch)).call.apply(_ref3, [this].concat(args))), _this3), _this3.currentAntdComponent = _input2.default.Search, _temp3), (0, _possibleConstructorReturn3.default)(_this3, _ret3);
  }

  return InputSearch;
}(_basicComponent2.default);
Input.Group = (_temp5 = _class4 = function (_React$Component) {
  (0, _inherits3.default)(InputGroup, _React$Component);

  function InputGroup() {
    var _ref4;

    var _temp4, _this4, _ret4;

    (0, _classCallCheck3.default)(this, InputGroup);

    for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    return _ret4 = (_temp4 = (_this4 = (0, _possibleConstructorReturn3.default)(this, (_ref4 = InputGroup.__proto__ || (0, _getPrototypeOf2.default)(InputGroup)).call.apply(_ref4, [this].concat(args))), _this4), _this4.state = {}, _temp4), (0, _possibleConstructorReturn3.default)(_this4, _ret4);
  }

  (0, _createClass3.default)(InputGroup, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isGroup: true
      };
    }
  }, {
    key: 'getChildrenNames',

    //验证是否是AntdFormComponent组件
    //所有AntdFormComponent都打上了标记
    value: function getChildrenNames() {
      var children = this.props.children;

      if (!children) {
        return;
      }
      if (children && !children[0]) {
        children = [children];
      }
      var names = [];
      children.forEach(function (v, k) {
        if (v.type.displayName !== 'AntdFormComponent') {
          console.error('InputGroup\u7684\u7B2C' + (k + 1) + '\u4E2A\u5B50\u7EC4\u4EF6\u4E0D\u662Fantd-form-component\u7EC4\u4EF6!');
        }
        if (v.props.name) {
          names.push(v.props.name);
        }
      });
      return names;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this5 = this;

      var names = this.getChildrenNames();
      this.context.on && this.context.on('form-errors', function (_ref5) {
        var name = _ref5.name,
            fieldError = _ref5.fieldError;

        if (!!~names.indexOf(name)) {
          //只处理input-group里表单组件的错误
          _this5.setState({
            fieldsError: (0, _extends4.default)({}, _this5.state.fieldsError, (0, _defineProperty3.default)({}, name, fieldError))
          });
        }
      });
    }
  }, {
    key: 'getErrorMessage',
    value: function getErrorMessage() {
      var fieldsError = this.state.fieldsError;

      if (!fieldsError) {
        return;
      }
      var messageArray = [];
      var message = '';
      for (var k in fieldsError) {
        if (fieldsError[k]) {
          //eslint-disable-next-line
          fieldsError[k].forEach(function (v) {
            messageArray.push(v.message);
          });
        }
      }
      messageArray.forEach(function (m, k) {
        if (k !== 0) {
          message += ',' + m;
        } else {
          message += m;
        }
      });
      return message;
    }
  }, {
    key: 'getValidateStatus',
    value: function getValidateStatus(errorMessage) {
      if (errorMessage) {
        return errorMessage ? 'error' : 'success';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          noFormItem = _props.noFormItem,
          other = (0, _objectWithoutProperties3.default)(_props, ['label', 'noFormItem']);

      var errorMessage = this.getErrorMessage();
      var context = this.context;
      if (noFormItem) {
        return _react2.default.createElement(_input2.default.Group, other);
      } else {
        return _react2.default.createElement(
          _form2.default.Item,
          (0, _extends4.default)({
            className: 'afc-input-group',
            hasFeedback: context.hasFeedback,
            wrapperCol: context.wrapperCol,
            labelCol: context.labelCol
          }, context.formItemProps, {
            label: label,
            help: errorMessage,
            validateStatus: this.getValidateStatus(errorMessage)
          }),
          _react2.default.createElement(_input2.default.Group, other)
        );
      }
    }
  }]);
  return InputGroup;
}(_react2.default.Component), _class4.contextTypes = {
  formItemProps: _propTypes2.default.object,
  form: _propTypes2.default.object,
  on: _propTypes2.default.func,
  hasFeedback: _propTypes2.default.bool,
  labelCol: _propTypes2.default.object,
  wrapperCol: _propTypes2.default.object
}, _class4.childContextTypes = {
  isGroup: _propTypes2.default.bool
}, _temp5);