'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _basicComponent = require('../basic-component');

var _basicComponent2 = _interopRequireDefault(_basicComponent);

var _input = require('../input');

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import PropTypes from 'prop-types';
//内部依赖包
var Password = function (_BasicComponent) {
  (0, _inherits3.default)(Password, _BasicComponent);

  function Password() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Password);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Password.__proto__ || (0, _getPrototypeOf2.default)(Password)).call.apply(_ref, [this].concat(args))), _this), _this.localeKey = 'afcPassword', _this.state = { passwordValue: '' }, _this.onPasswordChange = function (e) {
      var onChange = _this.props.onChange;

      _this.setState({
        passwordValue: e.target.value
      });
      onChange && onChange(e);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Password, [{
    key: 'getChekckPasswordRule',
    value: function getChekckPasswordRule() {
      var _this2 = this;

      var locale = this.locale;
      var rules = [{
        validator: function validator(rule, value, callback) {
          var passwordValue = _this2.state.passwordValue;
          var errors = [];
          if (passwordValue !== value) {
            errors.push({
              message: locale.afcPassword.checkErrorMsg
            });
          }
          callback(errors);
        }
      }];
      return rules;
    }
  }, {
    key: 'getOnlyLetterAndNumberRule',
    value: function getOnlyLetterAndNumberRule() {
      var locale = this.locale;
      return [{
        validator: function validator(rule, value, callback, source, options) {
          var errors = [];
          //数组和字母结合
          var pass = new RegExp('^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]*$').test(value);
          if (!pass && value !== '') {
            errors.push({
              message: locale.afcPassword.formatErrorMsg
            });
          }
          callback(errors);
        }
      }];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          rePassword = _props.rePassword,
          _props$type = _props.type,
          type = _props$type === undefined ? 'password' : _props$type,
          checkPassword = _props.checkPassword,
          _props$rules = _props.rules,
          rules = _props$rules === undefined ? [] : _props$rules,
          other = (0, _objectWithoutProperties3.default)(_props, ['rePassword', 'type', 'checkPassword', 'rules']);

      var locale = this.locale;
      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(_input2.default, (0, _extends3.default)({
          autoComplete: 'new-password',
          type: type
        }, other, {
          onChange: this.onPasswordChange,
          rules: [].concat((0, _toConsumableArray3.default)(rules), (0, _toConsumableArray3.default)(this.getOnlyLetterAndNumberRule()))
        })),
        (rePassword || checkPassword) &&
        //rePassword视为了兼容之前的formBuilder的api
        _react2.default.createElement(_input2.default, (0, _extends3.default)({
          autoComplete: 'new-password',
          type: type
        }, other, {
          label: locale.afcPassword.checkLabel,
          name: 'check-' + other.name,
          rules: this.getChekckPasswordRule()
        }))
      );
    }
  }]);
  return Password;
}(_basicComponent2.default); //外部依赖包


exports.default = Password;